/*
IO:


Display: Passes out a flattened array of scene objects


*/

var FOUNDATION_MATERIAL = new THREE.MeshPhongMaterial( { color: 0x333333, specular: 0x111111, shininess: 5 }  )
var OUTERWALL_MATERIAL = new THREE.MeshPhongMaterial({color: 0x445A77})

var materialWallRed = new THREE.MeshPhongMaterial({color: 0xBA3435})
var materialWallBlu = new THREE.MeshPhongMaterial({color: 0x445A77})

var materialFloorRed = new THREE.MeshPhongMaterial({color: 0xFEBA89})
var materialFloorBlu = new THREE.MeshPhongMaterial({color: 0x6B6964})

var materialCeilRed = new THREE.MeshPhongMaterial({color: 0xFEBA89})
var materialCeilBlu = new THREE.MeshPhongMaterial({color: 0x6B6964})

var materialDoorRed = new THREE.MeshPhongMaterial({color: 0xFFD6AA})
var materialDoorBlu = new THREE.MeshPhongMaterial({color: 0x788987})

var WORLD_DELIM = "|"
	var BUILDING_DELIM = ";"
		var FLOOR_DELIM = "]"
		var PORTAL_DELIM = "]"
		var ROOM_DELIM = "]"
			var PLATFORM_DELIM = "["
			var RAMP_DELIM = "["

var BORDER_DELIM = ":"
var POINT_DELIM = ","


var Kappa = 1

var Ramp_Pro = function(surface,bottom,dad){
	this.surface = surface
	this.dad = dad
	this.bottom = bottom
	this.genMesh = function(){
		return surface.genMesh()
	}
	this.exportVMF = function(){
		console.log("--exportVMF--")
		var worldObjects = []
		
		var flat = this.surface.simplify()
		console.log("decomposing")
		
		var faces = decompose_Shape(flat[0])
		console.log("merging")
		
		var shapes = merge_Tris(faces,flat[0])
		console.log("solidifying")
		
		var normal = new THREE.Vector3(0,-this.dad.thickness,0)
		var trace = this.dad.upper.position.clone().sub(this.dad.lower.position)
		trace.y = 0
		var space = trace.length()
		trace.multiplyScalar((this.dad.thickness/this.dad.height)*Kappa)
		console.log("ex",trace)
		for(var ii=0;ii<shapes.length;ii++){
			var product = new PRIM_SOLID()
			
			var upper = []
			var lower = []
			
			for(var jj=0;jj<shapes[ii].length;jj++){
				product.vertices.push(
					flat[1][shapes[ii][jj]].clone().add(normal),
					flat[1][shapes[ii][jj]].clone()
				)
				var A = (2*jj + 0) % (2 * shapes[ii].length)
				var B = (2*jj + 1) % (2 * shapes[ii].length)
				var C = (2*jj + 3) % (2 * shapes[ii].length)
				product.sides.push([A,B,C])
				upper.push(B)//1
				lower.push(A)//0
			}
			upper.reverse()
			product.sides.push(upper)
			
			if(this.dad.underFill){
				console.log("filled")
				product.vertices[0].y = this.bottom
				product.vertices[2].y = this.bottom
				product.vertices[4].y = this.bottom
				product.vertices[6].y = this.bottom
				if(product.vertices[5].y == this.bottom){
					console.log("merge front")
					product.vertices[6].copy(product.vertices[0])
					product.sides.splice(product.sides.length-3,1)
					product.materials.push(
						"dev/reflectivity_50",
						"dev/reflectivity_50",
						"dev/reflectivity_50",
						"dev/graygrid",
						0
					)
				}else{
					product.materials.push(
						"dev/reflectivity_50",
						"dev/reflectivity_50",
						"dev/reflectivity_50",
						"dev/reflectivity_50",
						"dev/graygrid",
						0
					)
				}
			}else{
				console.log("unfilled")
				if(product.vertices[4].y<this.bottom){
					console.log("based")
					product.vertices[4].y = this.bottom
					product.vertices[6].y = this.bottom
					product.vertices[4].add(trace)
					product.vertices[6].add(trace)
					product.materials.push(
						"dev/reflectivity_50",
						"dev/reflectivity_50",
						0,
						"dev/reflectivity_50",
						"dev/graygrid",
						"dev/reflectivity_50"
					)
				}else{
					product.materials.push(
						"dev/reflectivity_50",
						"dev/reflectivity_50",
						"dev/reflectivity_50",
						"dev/reflectivity_50",
						"dev/graygrid",
						"dev/reflectivity_50"
					)
				}
			}
			
			product.sides.push(lower)
			
			for(var jj=0; jj<product.vertices.length;jj++){
				var pos = new Point_Widget(product.vertices[jj],this)
				//reality.add(pos.object)
			}
			for(var jj=0; jj<product.sides.length;jj++){
				var pos = [product.vertices[product.sides[jj][0]],
					product.vertices[product.sides[jj][1]],
					product.vertices[product.sides[jj][2]]]
				displayPath(pos,0)
			}
			
			console.log("product",product)
			
			worldObjects.push(product)
		}
		console.log("finished")
		return worldObjects
	}
}

var Surface_Pro = function(border,normal){
	this.thickness = 8
	this.material = OUTERWALL_MATERIAL
	if(normal!=undefined){
		this.normal = normal
	}else{
		this.normal = border.calculateNormal()
	}
	this.quad = new THREE.Quaternion().setFromUnitVectors(this.normal,new THREE.Vector3(0,1,0))
	this.rot = findAngle(this.normal.x,this.normal.z)
	this.realCoords = [border.flatten()]
	this.project = function(product){
		for(var ii=0;ii<product.length;ii++){
			product[ii].applyQuaternion(this.quad)
			product[ii].applyAxisAngle(new THREE.Vector3(0,1,0),this.rot)
		}
		//verify offset!
		return product
	}
	var product = border.flatten()
	product = this.project(product)
	this.offset = product[0].y
	this.path = vector2path(product)
	if(!ClipperLib.Clipper.Orientation(this.path[0])){
		ClipperLib.Clipper.ReversePaths(this.path)
		this.realCoords[0].reverse()
	}
	this.subtract = function(border){
		var target = vector2path(this.project(border.flatten()))
		var tempCoords = border.flatten()
		
		var cpr = new ClipperLib.Clipper();
		cpr.StrictlySimple = true;
		if(!ClipperLib.Clipper.Orientation(target[0])){
			ClipperLib.Clipper.ReversePaths(target)
			tempCoords.reverse()
		}
		var solution_paths = new ClipperLib.Paths();
		
		
		cpr.AddPaths(this.path, ClipperLib.PolyType.ptSubject, true);
		cpr.AddPaths(target, ClipperLib.PolyType.ptClip, true);
		
		cpr.Execute(ClipperLib.ClipType.ctDifference, solution_paths, ClipperLib.PolyFillType.pftNonZero, ClipperLib.PolyFillType.pftNonZero);
		ClipperLib.Clipper.CleanPolygons(solution_paths)
		var realCoords = []
		for(var ii=0;ii<solution_paths.length;ii++){
			var pathCoords = []
			for(var jj=0;jj<solution_paths[ii].length;jj++){
				for(var kk=0;kk<target[0].length;kk++){
					if(solution_paths[ii][jj].X == target[0][kk].X && solution_paths[ii][jj].Y == target[0][kk].Y){
						pathCoords.push(tempCoords[kk].clone())
						break
					}
				}
				if(pathCoords.length>jj){continue}
				for(var kk=0;kk<this.path.length;kk++){
					for(var ll=0;ll<this.path[kk].length;ll++){
						if(solution_paths[ii][jj].X == this.path[kk][ll].X && solution_paths[ii][jj].Y == this.path[kk][ll].Y){
							pathCoords.push(this.realCoords[kk][ll].clone())
							break
						}
					}
					if(pathCoords.length>jj){break}
				}
			}
			realCoords.push(pathCoords)
			if(pathCoords.length<solution_paths[ii].length){
				console.log("Could not find Vertices!")
				console.log(solution_paths, this.path, target)
			}
		}
		this.realCoords = realCoords
		this.path = solution_paths
	}
	this.simplify = function(){
		//this function can break, later add a check that verifies target insert edges do not cross other edges
		var pathed = []
		var postions = []
		
		for(var ii=0;ii<this.path[0].length;ii++){
			pathed.push(this.path[0][ii])
			postions.push(this.realCoords[0][ii])
		}
		
		var included = []
		for(var ii=1;ii<this.path.length;ii++){
			included.push(ii)
		}
		
		while(included.length>0){
			var min_score = 10000000, score
			var target_path = included[0]
			var target_index = 0
			var target_insert = 0
			for(var ii=0;ii<included.length;ii++){
				for(var jj=0;jj<this.path[included[ii]].length;jj++){
					for(var kk=0;kk<pathed.length;kk++){
						score = this.realCoords[included[ii]][jj].distanceTo(postions[kk])
						if(score<min_score){
							min_score = score
							target_path = included[ii]
							target_index = jj
							target_insert = kk
						}
					}
				}
			}
			var insert_path = []
			var insert_pos = []
			for(var ii=0;ii<this.path[target_path].length;ii++){
				var index = (ii+target_index)%(this.path[target_path].length)
				insert_path.push(this.path[target_path][index])
				insert_pos.push(this.realCoords[target_path][index])
			}
			insert_path.push(this.path[target_path][target_index])
			insert_pos.push(this.realCoords[target_path][target_index])
			insert_path.push(pathed[target_insert])
			insert_pos.push(postions[target_insert])
			
			insert_path.unshift(target_insert+1,0)
			insert_pos.unshift(target_insert+1,0)
			Array.prototype.splice.apply(pathed, insert_path);
			Array.prototype.splice.apply(postions, insert_pos);
			included.splice(included.indexOf(target_path),1)
		}
		
		
		for(var ii=0;ii<pathed.length;ii++){
			var temp = new THREE.Vector3(pathed[ii].X,0,pathed[ii].Y)
			pathed[ii] = temp
		}
		if(pathed.length>4){
			//displayPath(pathed,300)
		}
		
		return [pathed,postions]
	}
	this.genMesh = function(){
		//start with just outer border
		var flat = this.simplify()
		var faces = decompose_Shape(flat[0])
		var geo = new THREE.Geometry()
		for(var ii=0;ii<faces.length;ii++){
			geo.faces.push(new THREE.Face3(faces[ii][0],faces[ii][1],faces[ii][2]))
		}
		geo.vertices = flat[1]
		return [geo]
	}
	this.display = function(){
		for(var ii=0;ii<this.path.length;ii++){
			var geometry = new THREE.Geometry()
			var v
			for(var jj=0;jj<this.path[ii].length;jj++){
				v = new THREE.Vector3(this.path[ii][jj].X,track,this.path[ii][jj].Y)
				geometry.vertices.push(v.clone())
			}
			v.add(new THREE.Vector3(0,5,0))
			geometry.vertices.push(v)
			//var line = new THREE.Line(geometry)
			//reality.add(line)
		}
		track += 20
	}
	this.exportVMF = function(){
		var worldObjects = []
		var flat = this.simplify()
		var faces = decompose_Shape(flat[0])
		var shapes = merge_Tris(faces,flat[0])
		for(var ii=0;ii<shapes.length;ii++){
			var product = new PRIM_SOLID()
			
			var upper = []
			var lower = []
			
			for(var jj=0;jj<shapes[ii].length;jj++){
				product.vertices.push(
					flat[1][shapes[ii][jj]].clone().sub(this.normal.clone().multiplyScalar(-this.thickness)),
					flat[1][shapes[ii][jj]].clone()
				)
				var A = 2*jj + 1
				var B = 2*jj
				var C = (2*jj + 2) % (2 * shapes[ii].length)
				product.sides.push([C,B,A])
				upper.push(A)
				lower.push(B)
			}
			upper.reverse()
			product.sides.push(lower)
			product.sides.push(upper)
			
			product.materials.push(
				"dev/reflectivity_50",
				"dev/reflectivity_50",
				"dev/reflectivity_50",
				"dev/reflectivity_50",
				0,
				"dev/graygrid"
			)
			
			worldObjects.push(product)
		}
		return worldObjects
	}
}

var Floor_Prim = function(height,dad){
	this.name = "Floor"
	this.details = ["height","wallWidth","outerThickness","calculateSurfaces"]
	this.dad = dad
	this.wallWidth = 8
	this.border = Square_Border(256,height,this)
	var hsl = this.dad.material.color.getHSL()
	this.border.material.color.setHSL(hsl.h,hsl.s,hsl.l)
	this.elevation = height
	this.outerThickness = 8
	this.height = 256
	this.display = function(){
		var product = [this.border.display()]
		return product
	}
	this.edit = function(){
		this.border.edit()
	}
	this.update = function(){
		this.dad.update()
	}
	this.move = function(vector){
		this.border.move(vector)
		this.elevation = this.border.vertices[0].position.y
		var stuff = this.display()
		for(var ii=0;ii<stuff.length;ii++){
			OBJECTS.push(stuff[ii])
		}
		
	}
	this.snap = function(){
		this.border.snap()
	}
	this.remove = function(target){
		this.dad.removeFloor(this)
	}
	this.calculateSurfaces = function(){
		track = 10
		var surfaces = Generate_Walls(this.border.flatten(),this.height,-this.wallWidth)
		for(var ii=0;ii<surfaces.length;ii++){
			if(this.dad.redTeam){
				surfaces[ii].material = materialWallRed
			}else{
				surfaces[ii].material = materialWallBlu
			}
		}
		for(var ii=0;ii<this.dad.portals.length;ii++){
			var index = this.border.after(this.dad.portals[ii].position.position)
			if(index>=0){
				var norm = surfaces[index].normal()
				var ins = this.dad.portals[ii].generateIns(norm,-this.wallWidth)
				var outs = this.dad.portals[ii].generateOuts(norm,-this.wallWidth)
				var cT = this.dad.portals[ii].calTop()
				var cB = this.dad.portals[ii].calBot()
				surfaces[index].addPortal(ins,outs,cB,cT)
			}
		}
		
		var outset = this.border.flatten()
		outset.push(outset[0])
		
		var inset = Inset_Path(outset,-this.wallWidth)
		
			
		for(var ii=0;ii<this.dad.rooms.length;ii++){
			outset.splice(outset.length-1,1)
			inset.splice(inset.length-1,1)
			var cuts = carve(inset,outset,this.dad.rooms[ii].border.flatten())
			for(var jj=0;jj<cuts[0].length;jj++){
				for(var kk=0;kk<cuts[0][jj].length/2;kk++){
					surfaces[jj].addPortal([cuts[0][jj][2*kk],cuts[0][jj][2*kk+1]],
						[cuts[1][jj][2*kk],cuts[1][jj][2*kk+1]],
						this.dad.rooms[ii].elevation-8,
						this.dad.rooms[ii].elevation+this.dad.rooms[ii].height+8)
				}
			}
			
			
			/*var index = this.border.after(this.dad.rooms[ii].position.position)
			if(index>=0){
				var norm = surfaces[index].normal()
				var ins = this.dad.rooms[ii].generateIns(norm,-this.wallWidth)
				var outs = this.dad.rooms[ii].generateOuts(norm,-this.wallWidth)
				var cT = this.dad.rooms[ii].calTop()
				var cB = this.dad.rooms[ii].calBot()
				surfaces[index].addPortal(ins,outs,cB,cT)
			}*/
		}
				
		surfaces = surfaces.concat(this.makeRoof())
		
		return surfaces
	}
	this.makeRoof = function(){
		var myindex = 0
		for(var ii=0;ii<this.dad.floors.length;ii++){
			if(this==this.dad.floors[ii]){
				myindex = ii
				break
			}
		}
		
		var A = this.border.flatten()
		A.push(A[0])
		A = Inset_Path(A,-this.wallWidth)
		A.splice(A.length-1,1)
		
		if(myindex<this.dad.floors.length-1){
			var solutions = []
			
			var B = this.dad.floors[myindex+1].border.flatten()
			for(var ii=0;ii<A.length;ii++){
				A[ii].y = 0
			}
			for(var ii=0;ii<B.length;ii++){
				B[ii].y = 0
			}
			B.push(B[0])
			B = Inset_Path(B,-this.dad.floors[myindex+1].wallWidth)
			B.splice(B.length-1,1)
			
			var vA = vector2path(A)
			var vB = vector2path(B)
			var solution_paths = new ClipperLib.Paths();
			
			var C = findPathIntersections(A,B)
			for(var ii=0;ii<C.length;ii++){
				var pos = new Point_Widget(C[ii][2],undefined)
				reality.add(pos.object)
			}
			
			var cpr = new ClipperLib.Clipper();
			cpr.AddPaths(vA, ClipperLib.PolyType.ptSubject, true);
			cpr.AddPaths(vB, ClipperLib.PolyType.ptClip, true);
			cpr.Execute(ClipperLib.ClipType.ctDifference, solution_paths, ClipperLib.PolyFillType.pftNonZero, ClipperLib.PolyFillType.pftNonZero);
			
			for(var path=0;path<solution_paths.length;path++){
				var product = []
				for(var ii=0;ii<solution_paths[path].length;ii++){
					var origin = new THREE.Vector3(solution_paths[path][ii].X,0,solution_paths[path][ii].Y)
					var real = new THREE.Vector3()
					var min_score = 99999999
					for(var jj=0;jj<A.length;jj++){
						if(A[jj].distanceTo(origin)<min_score){
							min_score = A[jj].distanceTo(origin)
							real = A[jj]
						}
					}
					for(var jj=0;jj<C.length;jj++){
						if(C[jj][2].distanceTo(origin)<min_score){
							min_score = C[jj][2].distanceTo(origin)
							real = C[jj][2]
						}
					}
					for(var jj=0;jj<B.length;jj++){
						if(B[jj].distanceTo(origin)<min_score){
							min_score = B[jj].distanceTo(origin)
							real = B[jj]
						}
					}
					product.push(real)
				}
				var tempBorder = new Border_Widget(this)
				for(var ii=0;ii<product.length;ii++){
					product[ii].y = this.elevation + this.height + 16
					tempBorder.vertices.push(new Point_Widget(product[ii],tempBorder))
				}
				solutions.push(new Surface_Pro(tempBorder))
				solutions[solutions.length-1].thickness = 16
			}
			return solutions
		}else{
			var tempBorder = new Border_Widget(this)
			for(var ii=A.length-1;ii>=0;ii--){
				A[ii].y = this.elevation + this.height + 16
				tempBorder.vertices.push(new Point_Widget(A[ii],tempBorder))
			}
		}
		var surf = new Surface_Pro(tempBorder)
		surf.thickness = 16
		return [surf]
	}
	this.save = function(){
		var total = this.border.save()+FLOOR_DELIM
		total+=this.wallWidth+FLOOR_DELIM+this.elevation+FLOOR_DELIM+this.outerThickness+FLOOR_DELIM+this.height+FLOOR_DELIM
		return total
	}
	this.load = function(worldText){
		
		var tuple = gatherThoughts(worldText,0,FLOOR_DELIM)
		var thought = tuple[0]
		var textFocus = tuple[1]
		this.border.load(thought)
		tuple = gatherThoughts(worldText,textFocus,FLOOR_DELIM)
		thought = tuple[0]
		textFocus = tuple[1]
		this.wallWidth = parseInt(tuple[0])
		tuple = gatherThoughts(worldText,textFocus,FLOOR_DELIM)
		thought = tuple[0]
		textFocus = tuple[1]
		this.elevation = parseInt(tuple[0])
		tuple = gatherThoughts(worldText,textFocus,FLOOR_DELIM)
		thought = tuple[0]
		textFocus = tuple[1]
		this.outerThickness = parseInt(tuple[0])
		tuple = gatherThoughts(worldText,textFocus,FLOOR_DELIM)
		thought = tuple[0]
		textFocus = tuple[1]
		this.height = parseInt(tuple[0])
	}
	this.exportVMF = function(){
		var worldObjects = []
		var entityObjects = []
		
		var walls = this.calculateSurfaces()
		for(var ii=0;ii<walls.length;ii++){
			worldObjects = worldObjects.concat(walls[ii].exportVMF())
		}
		
		
		return [worldObjects,entityObjects]
	}
}

var Room_Prim = function(height,dad){
	this.name = "Room"
	this.details = ["height","elevation","wallWidth","addPlatform","addRamp"]
	this.dad = dad
	this.wallWidth = 4
	this.elevation = height
	this.border = Square_Border(128,height,this)
	var hsl = this.dad.material.color.getHSL()
	this.border.material.color.setHSL(hsl.h,hsl.s+.5,hsl.l)
	this.height = 192
	this.ramps = []
	this.platforms = []
	this.display = function(){
		var product = [this.border.display()]
		for(var ii=0;ii<this.ramps.length;ii++){
			var stuff = this.ramps[ii].display()
			for(var jj=0;jj<stuff.length;jj++){
				product.push(stuff[jj])
			}
		}
		for(var ii=0;ii<this.platforms.length;ii++){
			var stuff = this.platforms[ii].display()
			for(var jj=0;jj<stuff.length;jj++){
				product.push(stuff[jj])
			}
		}
		return product
	}
	this.edit = function(){
		this.border.edit()
	}
	this.update = function(){
		//guarantee first vertex pair is concave
		//while(orientation(this.border.flatten()))
		//	this.border.shift()
		//
		if(this.elevation!=this.border.vertices[0].position.y){
			this.move(new THREE.Vector3(0,this.elevation-this.border.vertices[0].position.y,0))
		}
		this.dad.update()
	}
	this.move = function(vector){
		this.border.move(vector)
		this.elevation = this.border.vertices[0].position.y
	}
	this.moveChildren = function(vector){
		for(var ii=0;ii<this.platforms.length;ii++){
			this.platforms[ii].move(vector)
		}
		for(var ii=0;ii<this.ramps.length;ii++){
			this.ramps[ii].move(vector)
		}
	}
	this.remove = function(target){
		this.dad.removeRoom(this)
	}
	this.calculateSurfaces = function(){
		track = 10
		
		this.border.invert()
		var surfaces = Generate_Walls(this.border.flatten(),this.height,-this.wallWidth)
		for(var ii=0;ii<surfaces.length;ii++){
			if(this.dad.redTeam){
				surfaces[ii].material = materialWallRed
			}else{
				surfaces[ii].material = materialWallBlu
			}
		}
		for(var ii=0;ii<this.dad.portals.length;ii++){
			var index = this.border.after(this.dad.portals[ii].position.position)
			if(index>=0){
				var norm = surfaces[index].normal()
				var ins = this.dad.portals[ii].generateIns(norm,-this.wallWidth)
				var outs = this.dad.portals[ii].generateOuts(norm,-this.wallWidth)
				
				var cT = this.dad.portals[ii].calTop()
				var cB = this.dad.portals[ii].calBot()
				surfaces[index].addPortal(ins,outs,cB,cT)
			}
		}
		var flat = this.border.flatten()
		flat.push(flat[0])
		var floor = Inset_Path(flat,-this.wallWidth)
		var tempBorder = new Border_Widget(this)
		for(var ii=0;ii<floor.length-1;ii++){
			tempBorder.vertices.push(new Point_Widget(floor[ii],tempBorder))
		}
		surfaces.push(new Surface_Pro(tempBorder.clone(),new THREE.Vector3(0,-1,0)))
		if(this.dad.redTeam){
			surfaces[surfaces.length-1].material = materialFloorRed
		}else{
			surfaces[surfaces.length-1].material = materialFloorBlu
		}
		tempBorder.invert()
		for(var ii=0;ii<floor.length-1;ii++){
			tempBorder.vertices[ii].position.y+=this.height
		}
		surfaces.push(new Surface_Pro(tempBorder.clone(),new THREE.Vector3(0,1,0)))
		if(this.dad.redTeam){
			surfaces[surfaces.length-1].material = materialCeilRed
		}else{
			surfaces[surfaces.length-1].material = materialCeilBlu
		}
		for(var ii=0;ii<this.platforms.length;ii++){
			surfaces = surfaces.concat(this.platforms[ii].calculateSurfaces())
		}
		for(var ii=0;ii<this.ramps.length;ii++){
			surfaces = surfaces.concat(this.ramps[ii].calculateSurfaces())
		}
		this.border.invert()
		return surfaces
	}
	this.addPlatform = function(worldText){
		//compute current height
		this.platforms.push(new Platform_Prim(this.elevation,this))
		if(worldText!=undefined){
			this.platforms[this.platforms.length-1].load(worldText)
		}else{
			this.platforms[this.platforms.length-1].move(this.border.vertices[0].position)
		}
		var stuff = this.display()
		for(var ii=0;ii<stuff.length;ii++){
			OBJECTS.push(stuff[ii])
		}
	}
	this.addRamp = function(worldText){
		//compute current height
		this.ramps.push(new Ramp_Prim(this.elevation,this))
		if(worldText!=undefined){
			this.ramps[this.ramps.length-1].load(worldText)
		}else{
			this.ramps[this.ramps.length-1].move(this.border.vertices[0].position)
		}
		var stuff = this.display()
		for(var ii=0;ii<stuff.length;ii++){
			OBJECTS.push(stuff[ii])
		}
	}
	this.removeCatwalk = function(target){
		for(var ii=0;ii<this.catwalks.length;ii++){
			if(this.catwalks[ii]==target){
				this.catwalks.splice(ii,1)
				break
			}
		}
		WORLD.update()
		this.update()
	}
	this.removePlatform = function(target){
		for(var ii=0;ii<this.platforms.length;ii++){
			if(this.platforms[ii]==target){
				this.platforms.splice(ii,1)
				break
			}
		}
		WORLD.update()
		this.update()
	}
	this.removeRamp = function(target){
		for(var ii=0;ii<this.ramps.length;ii++){
			if(this.ramps[ii]==target){
				this.ramps.splice(ii,1)
				break
			}
		}
		WORLD.update()
		this.update()
	}
	this.snap = function(){
		this.border.snap()
		this.snapChildren()
		console.log("ho")
	}
	this.snapChildren = function(){
		console.log("hr")
		for(var ii=0;ii<this.platforms.length;ii++){
			this.platforms[ii].snap()
		}
		for(var ii=0;ii<this.ramps.length;ii++){
			this.ramps[ii].snap()
		}
	}
	this.save = function(){
		var total = this.border.save()+ROOM_DELIM
		total+=this.wallWidth+ROOM_DELIM+this.height+ROOM_DELIM
		for(var ii=0;ii<this.platforms.length;ii++){
			total += "P"+this.platforms[ii].save() + ROOM_DELIM
		}
		for(var ii=0;ii<this.ramps.length;ii++){
			total += "R"+this.ramps[ii].save() + ROOM_DELIM
		}
		return total
	}
	this.load = function(worldText){
		var tuple = gatherThoughts(worldText,0,ROOM_DELIM)
		var thought = tuple[0]
		var textFocus = tuple[1]
		this.border.load(thought)
		tuple = gatherThoughts(worldText,textFocus,ROOM_DELIM)
		thought = tuple[0]
		textFocus = tuple[1]
		this.wallWidth = parseInt(tuple[0])
		tuple = gatherThoughts(worldText,textFocus,ROOM_DELIM)
		thought = tuple[0]
		textFocus = tuple[1]
		this.height = parseInt(tuple[0])
		while(textFocus<worldText.length){
			tuple = gatherThoughts(worldText,textFocus,ROOM_DELIM)
			thought = tuple[0]
			textFocus = tuple[1]
			if(thought[0]=="P"){
				this.addPlatform(thought.slice(1))
			}
			if(thought[0]=="R"){
				this.addRamp(thought.slice(1))
			}
		}
	}
	this.exportVMF = function(){
		var worldObjects = []
		var entityObjects = []
		var walls = this.calculateSurfaces()
		for(var ii=0;ii<walls.length;ii++){
			worldObjects = worldObjects.concat(walls[ii].exportVMF())
		}
		for(var ii=0;ii<platforms.length;ii++){
			worldObjects = worldObjects.concat(platforms[ii].exportVMF())
		}
		return [worldObjects,entityObjects]
	}
}

var Portal_Prim = function(position,dad){
	this.name = "Portal"
	this.details = ["width","height","elevation","borderWidth"]
	this.dad = dad
	this.position = new Point_Widget(position,this)
	var hsl = this.dad.material.color.getHSL()
	this.position.object.material.color.setHSL(hsl.h,hsl.s+.1,hsl.l+.3)
	this.width = 64
	this.borderWidth = 8
	this.borderDepth = 0 //not in use, will be later probs
	this.height = 64	
	this.elevation = 0
	this.snap = function(){
		this.position.snap()
	}
	this.calBot = function(){
		return this.position.position.y - this.borderWidth
	}
	this.calTop = function(){
		return this.position.position.y + this.height + this.borderWidth
	}
	this.display = function(){
		return [this.position.display()]
	}
	this.edit = function(){
		WORLD.update()
		OBJECTS.push(this.position.display())
	}
	this.update = function(){
		if(this.elevation!=this.position.position.y){
			this.move(new THREE.Vector3(0,this.elevation-this.position.position.y,0))
		}
		this.position.display()
	}
	this.move = function(vector){
		this.position.move(vector)
		this.elevation = this.position.position.y
	}
	this.removeChild = function(){
		this.dad.removePortal(this)
	}
	this.calculateSurfaces = function(){
		if(this.A==0||this.B==0){
			return []
		}
		var product = []
		var temp = new Border_Widget(this)
		temp.vertices.push(new Point_Widget(this.A[0].clone(),temp))
		temp.vertices.push(new Point_Widget(this.B[1].clone(),temp))
		temp.vertices.push(new Point_Widget(this.B[0].clone(),temp))
		temp.vertices.push(new Point_Widget(this.A[1].clone(),temp))
		product.push(new Surface_Pro(temp))
		var temp = new Border_Widget(this)
		temp.vertices.push(new Point_Widget(this.A[1].clone()
			.add(new THREE.Vector3(0,this.height,0))
			,temp))
		temp.vertices.push(new Point_Widget(this.B[0].clone()
			.add(new THREE.Vector3(0,this.height,0))
			,temp))
		temp.vertices.push(new Point_Widget(this.B[1].clone()
			.add(new THREE.Vector3(0,this.height,0))
			,temp))
		temp.vertices.push(new Point_Widget(this.A[0].clone()
			.add(new THREE.Vector3(0,this.height,0))
			,temp))
		product.push(new Surface_Pro(temp))
		
		var offset = this.A[0].clone().sub(this.A[1]).normalize().multiplyScalar(this.borderWidth)
		this.A[0].sub(offset)
		this.A[1].add(offset)
		this.B[0].add(offset)
		this.B[1].sub(offset)
		
		var temp = new Border_Widget(this)
		temp.vertices.push(new Point_Widget(this.A[0].clone()
			.add(new THREE.Vector3(0,0,0))
			,temp))
		temp.vertices.push(new Point_Widget(this.A[0].clone()
			.add(new THREE.Vector3(0,this.height,0))
			,temp))
		temp.vertices.push(new Point_Widget(this.B[1].clone()
			.add(new THREE.Vector3(0,this.height,0))
			,temp))
		temp.vertices.push(new Point_Widget(this.B[1].clone()
			.add(new THREE.Vector3(0,0,0))
			,temp))
		product.push(new Surface_Pro(temp))
		
		var temp = new Border_Widget(this)
		temp.vertices.push(new Point_Widget(this.B[0].clone()
			.add(new THREE.Vector3(0,0,0))
			,temp))
		temp.vertices.push(new Point_Widget(this.B[0].clone()
			.add(new THREE.Vector3(0,this.height,0))
			,temp))
		temp.vertices.push(new Point_Widget(this.A[1].clone()
			.add(new THREE.Vector3(0,this.height,0))
			,temp))
		temp.vertices.push(new Point_Widget(this.A[1].clone()
			.add(new THREE.Vector3(0,0,0))
			,temp))
		product.push(new Surface_Pro(temp))
		
		
		for(var ii=0;ii<4;ii++){
			product[ii].thickness = this.borderWidth
			if(this.dad.redTeam){
				product[ii].material = materialDoorRed
			}else{
				product[ii].material = materialDoorBlu
			}
		}
		return product
	}
	this.generateIns = function(normal,width){
		var offset = normal.clone()
		var extrusion = normal.clone().normalize().multiplyScalar(width)
		offset = new THREE.Vector3(offset.z,offset.y,-offset.x)
		//offset.x, offset.z = offset.z, -offset.x
		offset.multiplyScalar(this.width/2)
		offset.multiplyScalar(1+this.borderWidth/offset.length())
		var product = []
		product.push(
			this.position.position.clone()
				.add(offset)
				.add(extrusion)
				.add(new THREE.Vector3(0,0,0)))
		product.push(
			this.position.position.clone()
				.sub(offset)
				.add(extrusion)
				.add(new THREE.Vector3(0,0,0)))
		if(this.A==0){
			this.A = [product[0].clone(),product[1].clone()]
		}else{
			this.B = [product[0].clone(),product[1].clone()]
		}
		return product
	}
	this.generateOuts = function(normal,width){
		var offset = normal.clone()
		var extrusion = normal.clone().normalize().multiplyScalar(width)
		offset = new THREE.Vector3(offset.z,offset.y,-offset.x)
		//offset.x, offset.z = offset.z, -offset.x
		offset.multiplyScalar(this.width/2)
		offset.multiplyScalar(1+this.borderWidth/offset.length())
		var product = []
		product.push(
			this.position.position.clone()
				.add(offset)
				.add(new THREE.Vector3(0,0,0)))
		product.push(
			this.position.position.clone()
				.sub(offset)
				.add(new THREE.Vector3(0,0,0)))
		return product
	}
	this.generateCut = function(normal,width){
		var offset = normal.clone()
		var extrusion = normal.clone().normalize().multiplyScalar(width)
		offset = new THREE.Vector3(offset.z,offset.y,-offset.x)
		//offset.x, offset.z = offset.z, -offset.x
		offset.multiplyScalar(this.width/2)
		var product = new Border_Widget(this)
		if(this.elevation>0){
			product.vertices.push(
				new Point_Widget(
					this.position.position.clone()
					.add(offset)
					.add(extrusion)
					.add(new THREE.Vector3(0,this.elevation,0)),product))
			product.vertices.push(
				new Point_Widget(
					this.position.position.clone()
					.add(offset)
					.add(extrusion)
					.add(new THREE.Vector3(0,this.height+this.elevation,0)),product))
			product.vertices.push(
				new Point_Widget(
					this.position.position.clone()
					.sub(offset)
					.add(extrusion)
					.add(new THREE.Vector3(0,this.height+this.elevation,0)),product))
			product.vertices.push(
				new Point_Widget(
					this.position.position.clone()
					.sub(offset)
					.add(extrusion)
					.add(new THREE.Vector3(0,this.elevation,0)),product))
		}else{
			product.vertices.push(
				new Point_Widget(
					this.position.position.clone()
					.add(offset)
					.add(extrusion)
					.add(new THREE.Vector3(0,0,0)),product))
			product.vertices.push(
				new Point_Widget(
					this.position.position.clone()
					.add(offset)
					.add(extrusion)
					.add(new THREE.Vector3(0,this.height,0)),product))
			product.vertices.push(
				new Point_Widget(
					this.position.position.clone()
					.sub(offset)
					.add(extrusion)
					.add(new THREE.Vector3(0,this.height,0)),product))
			product.vertices.push(
				new Point_Widget(
					this.position.position.clone()
					.sub(offset)
					.add(extrusion)
					.add(new THREE.Vector3(0,0,0)),product))	
		}
		return product
	}
	this.save = function(){
		var total = this.position.save()+PORTAL_DELIM
		total+=this.width+PORTAL_DELIM+this.height+PORTAL_DELIM+this.elevation+PORTAL_DELIM
		return total
	}
	this.load = function(worldText){
		var tuple = gatherThoughts(worldText,0,PORTAL_DELIM)
		var thought = tuple[0]
		var textFocus = tuple[1]
		this.position.load(thought)
		tuple = gatherThoughts(worldText,textFocus,PORTAL_DELIM)
		thought = tuple[0]
		textFocus = tuple[1]
		this.width = parseInt(tuple[0])
		tuple = gatherThoughts(worldText,textFocus,PORTAL_DELIM)
		thought = tuple[0]
		textFocus = tuple[1]
		this.height = parseInt(tuple[0])
		tuple = gatherThoughts(worldText,textFocus,PORTAL_DELIM)
		thought = tuple[0]
		textFocus = tuple[1]
		this.elevation = parseInt(tuple[0])
		
	}
	this.exportVMF = function(){
		var worldObjects = []
		var entityObjects = []
		var walls = this.calculateSurfaces()
		for(var ii=0;ii<walls.length;ii++){
			worldObjects = worldObjects.concat(walls[ii].exportVMF())
		}
		return [worldObjects,entityObjects]
	}
}

var Platform_Prim = function(height,dad){
	this.name = "Platform"
	this.details = ["underFill","elevation","thickness"]
	this.underFill = true
	this.dad = dad
	this.border = Square_Border(64,height+32,this)
	var hsl = this.dad.border.material.color.getHSL()
	this.border.material.color.setHSL(hsl.h,hsl.s,hsl.l-.2)
	this.elevation = 32
	this.thickness = 16
	this.move = function(vector){
		this.border.move(vector)
		this.elevation = this.border.vertices[0].position.y
	}
	this.update = function(){
		if(this.elevation!=this.border.vertices[0].position.y){
			this.move(new THREE.Vector3(0,this.elevation-this.border.vertices[0].position.y,0))
		}
		this.dad.update()
	}
	this.snap = function(){
		console.log("hm")
		this.border.snap()
	}
	this.edit = function(){
		this.border.edit()
	}
	this.display = function(){
		return [this.border.display()]
	}
	this.remove = function(){
		this.dad.removePlatform(this)
	}
	this.load = function(worldText){
		var tuple = gatherThoughts(worldText,0,PLATFORM_DELIM)
		var thought = tuple[0]
		var textFocus = tuple[1]
		this.border.load(thought)
		var hsl = this.dad.border.material.color.getHSL()
		this.border.material.color.setHSL(hsl.h,hsl.s,hsl.l-.2)
		this.move(new THREE.Vector3(0,0,0))
		tuple = gatherThoughts(worldText,textFocus,PLATFORM_DELIM)
		thought = tuple[0]
		textFocus = tuple[1]
		this.underFill = (parseInt(tuple[0])==1)
		
	}
	this.save = function(){
		var total = this.border.save()+PLATFORM_DELIM
			+(this.underFill ? "1" : "0")+PLATFORM_DELIM
		
		return total
	}
	this.calculateSurfaces = function(){
		var A = this.border.flatten()
		var B = this.dad.border.flatten()//root wall
		for(var ii=0;ii<B.length;ii++){
			B[ii].y = this.elevation
		}
		B.push(B[0])
		B = Inset_Path(B,-this.dad.wallWidth)
		B.splice(B.length-1,1)
		
		var vA = vector2path(A)
		var vB = vector2path(B)
		var solution_paths = new ClipperLib.Paths();
		var C = findPathIntersections(A,B)
		for(var ii=0;ii<C.length;ii++){
			C[ii][2].y = this.elevation
		}
		console.log(this.elevation)
		console.log(A[0].y)
		console.log(C[0][2].y)
		
		for(var ii=0;ii<C.length;ii++){
			var pos = new Point_Widget(C[ii][2],undefined)
			reality.add(pos.object)
		}
		var cpr = new ClipperLib.Clipper();
		cpr.AddPaths(vA, ClipperLib.PolyType.ptSubject, true);
		cpr.AddPaths(vB, ClipperLib.PolyType.ptClip, true);
		
		cpr.Execute(ClipperLib.ClipType.ctIntersection, solution_paths, ClipperLib.PolyFillType.pftNonZero, ClipperLib.PolyFillType.pftNonZero);
		console.log(solution_paths)
		var product = []
		for(var ii=0;ii<solution_paths[0].length;ii++){
			var origin = new THREE.Vector3(solution_paths[0][ii].X,0,solution_paths[0][ii].Y)
			var real = new THREE.Vector3()
			var min_score = 99999999
			for(var jj=0;jj<A.length;jj++){
				if(A[jj].distanceTo(origin)<min_score){
					min_score = A[jj].distanceTo(origin)
					real = A[jj]
				}
			}
			for(var jj=0;jj<C.length;jj++){
				if(C[jj][2].distanceTo(origin)<min_score){
					min_score = C[jj][2].distanceTo(origin)
					real = C[jj][2]
				}
			}
			for(var jj=0;jj<B.length;jj++){
				if(B[jj].distanceTo(origin)<min_score){
					min_score = B[jj].distanceTo(origin)
					real = B[jj]
				}
			}
			product.push(real)
		}
		var tempBorder = new Border_Widget(this)
		for(var ii=0;ii<product.length;ii++){
			tempBorder.vertices.push(new Point_Widget(product[ii],tempBorder))
		}
		var surfaces = [new Surface_Pro(tempBorder.clone())]
		surfaces[0].thickness = this.thickness
		if(this.underFill){
			tempBorder.move(new THREE.Vector3(0,-this.thickness,0))
			surfaces.push(new Surface_Pro(tempBorder.clone()))
			surfaces[1].thickness = this.elevation-this.thickness-this.dad.elevation
		}
		return surfaces
	}
	this.removeChild = function(){
		this.dad.removePlatform(this)
	}
}

var Ramp_Prim = function(elevation,dad){
	this.name = "Ramp"
	this.details = ["elevation","height","underFill","width","thickness","stairs","base"]
	this.upper = new Point_Widget(new THREE.Vector3(0,elevation+32,0), this)
	this.lower = new Point_Widget(new THREE.Vector3(0,elevation,64), this)
	this.dad = dad
	this.stairs = false
	this.underFill = true
	this.elevation = 32
	this.height = 32
	this.width = 64
	this.thickness = 16
	this.base = elevation
	this.update = function(){
		if(this.elevation!=this.lower.position.y){
			this.move(new THREE.Vector3(0,this.elevation-this.lower.position.y,0))
		}
		this.upper.position.y = this.elevation + this.height
		if(this.height != this.upper.position.y - this.lower.position.y){
			this.upper.move(new THREE.Vector3(0,this.height - this.upper.position.y + this.lower.position.y,0))
		}
		this.display()
	}
	this.move = function(vector){
		this.lower.move(vector)
		this.upper.move(vector)
		this.elevation = this.lower.position.y
		this.height = this.upper.position.y - this.elevation
	}
	this.display = function(){
		return [this.upper.display(),this.lower.display()]
	}
	this.edit = function(){
		WORLD.update()
	}
	this.removeChild = function(){
		this.dad.removeRamp(this)
	}
	
	this.snap = function(){
		this.upper.snap()
		this.lower.snap()
	}
	this.calculateSurfaces = function(){
		var normal = this.upper.position.clone().sub(this.lower.position)
		normal.y = 0
		var ox = normal.x
		normal.x = normal.z
		normal.z = -ox
		normal.normalize().multiplyScalar(this.width/2)
		console.log("norm:",normal)
		var border = new Border_Widget(this)
		border.vertices.push(
			new Point_Widget(this.lower.position.clone().sub(normal),border),
			new Point_Widget(this.lower.position.clone().add(normal),border),
			new Point_Widget(this.upper.position.clone().add(normal),border),
			new Point_Widget(this.upper.position.clone().sub(normal),border)
		)
		var trace = this.upper.position.clone().sub(this.lower.position)
		trace.y = 0
		trace.multiplyScalar((this.thickness/this.height)*Kappa)
		console.log("pre",trace)
		return [new Ramp_Pro(new Surface_Pro(border),this.base,this)]
	}
	this.save = function(){
		var total = this.upper.save()+RAMP_DELIM
			+this.lower.save()+RAMP_DELIM
			+this.width+RAMP_DELIM+this.height+RAMP_DELIM
			+this.elevation+RAMP_DELIM+this.thickness+RAMP_DELIM
			+this.base+RAMP_DELIM+(this.underFill ? "1" : "0")+RAMP_DELIM
		return total
	}
	this.load = function(worldText){
		var tuple = gatherThoughts(worldText,0,RAMP_DELIM)
		var thought = tuple[0]
		var textFocus = tuple[1]
		this.upper.load(thought)
		tuple = gatherThoughts(worldText,textFocus,RAMP_DELIM)
		thought = tuple[0]
		textFocus = tuple[1]
		this.lower.load(thought)
		tuple = gatherThoughts(worldText,textFocus,RAMP_DELIM)
		thought = tuple[0]
		textFocus = tuple[1]
		this.width = parseInt(tuple[0])
		tuple = gatherThoughts(worldText,textFocus,RAMP_DELIM)
		thought = tuple[0]
		textFocus = tuple[1]
		this.height = parseInt(tuple[0])
		tuple = gatherThoughts(worldText,textFocus,RAMP_DELIM)
		thought = tuple[0]
		textFocus = tuple[1]
		this.elevation = parseInt(tuple[0])
		tuple = gatherThoughts(worldText,textFocus,RAMP_DELIM)
		thought = tuple[0]
		textFocus = tuple[1]
		this.thickness = parseInt(tuple[0])
		tuple = gatherThoughts(worldText,textFocus,RAMP_DELIM)
		thought = tuple[0]
		textFocus = tuple[1]
		this.base = parseInt(tuple[0])
		tuple = gatherThoughts(worldText,textFocus,RAMP_DELIM)
		thought = tuple[0]
		textFocus = tuple[1]
		this.underFill = (parseInt(tuple[0])==1)
	}
	this.exportVMF = function(){
		var worldObjects = []
		var entityObjects = []
		var walls = this.calculateSurfaces()
		for(var ii=0;ii<walls.length;ii++){
			worldObjects = worldObjects.concat(walls[ii].exportVMF())
		}
		return [worldObjects,entityObjects]
	}
}

var Building_Prim = function(dad){
	this.name = "Building"
	this.details = ["baseElevation","addFloor","addRoom","addPortal","calculateSurfaces","redTeam"]
	this.material = new THREE.MeshBasicMaterial();
	this.material.color.setHSL(Math.random(),.3,.5)
	this.baseElevation = 0
	this.dad = dad
	this.redTeam = false
	this.floors = [new Floor_Prim(0,this)]
	this.rooms = []
	this.portals = []
	this.display = function(){
		var product = []
		for(var ii=0;ii<this.floors.length;ii++){
			var stuff = this.floors[ii].display()
			for(var jj=0;jj<stuff.length;jj++){
				product.push(stuff[jj])
			}
		}
		for(var ii=0;ii<this.rooms.length;ii++){
			var stuff = this.rooms[ii].display()
			for(var jj=0;jj<stuff.length;jj++){
				product.push(stuff[jj])
			}
		}
		for(var ii=0;ii<this.portals.length;ii++){
			var stuff = this.portals[ii].display()
			for(var jj=0;jj<stuff.length;jj++){
				product.push(stuff[jj])
			}
		}
		return product
	}
	this.addRoom = function(worldText){
		this.rooms.push(new Room_Prim(this.baseElevation,this))
		if(worldText!=undefined){
			this.rooms[this.rooms.length-1].load(worldText)
		}else{
			this.rooms[this.rooms.length-1].move(this.floors[0].border.vertices[0].position)
			//this.rooms[this.rooms.length-1].move(new THREE.Vector3(0,0,32))
		}
		var stuff = this.rooms[this.rooms.length-1].display()
		for(var ii=0;ii<stuff.length;ii++){
			OBJECTS.push(stuff[ii])
		}
	}
	this.addPortal = function(worldText){
		this.portals.push(new Portal_Prim(new THREE.Vector3(0,this.elevation,0),this))
		if(worldText!=undefined){
			this.portals[this.portals.length-1].load(worldText)
		}else{
			this.portals[this.portals.length-1].move(this.floors[0].border.vertices[0].position)
			this.portals[this.portals.length-1].move(new THREE.Vector3(0,0,32))
		}
		var stuff = this.portals[this.portals.length-1].display()
		for(var ii=0;ii<stuff.length;ii++){
			OBJECTS.push(stuff[ii])
		}
	}
	this.addFloor = function(worldText){
		//compute current height
		
		if(worldText==undefined){
			var height = this.baseElevation+this.floors[this.floors.length-1].elevation+this.floors[this.floors.length-1].height;
			var last_floor = this.floors[this.floors.length-1].border.clone()
			this.floors.push(new Floor_Prim(height,this))
			last_floor.dad = this.floors[this.floors.length-1]
			this.floors[this.floors.length-1].border = last_floor
			var hsl = this.material.color.getHSL()
			last_floor.material.color.setHSL(hsl.h,hsl.s,hsl.l)
			this.floors[this.floors.length-1].border.move(new THREE.Vector3(0,this.floors[this.floors.length-1].height,0))
			this.floors[this.floors.length-1].border.dad = this.floors[this.floors.length-1]
		}else{
			this.floors.push(new Floor_Prim(0,this))
			this.floors[this.floors.length-1].load(worldText)
		}
		this.update()
		var stuff = this.display()
		for(var ii=0;ii<stuff.length;ii++){
			OBJECTS.push(stuff[ii])
		}
	}	
	this.update = function(){
		var height = this.baseElevation
		if(this.floors[0].elevation!=this.height){
			this.move(new THREE.Vector3(0,height-this.floors[0].elevation,0))
		}
		for(var ii=0;ii<this.floors.length;ii++){
			var d = height-this.floors[ii].elevation
			this.floors[ii].move(new THREE.Vector3(0,d,0))
			height += this.floors[ii].height
		}
	}
	this.removeFloor = function(target){
		for(var ii=0;ii<this.floors.length;ii++){
			if(this.floors[ii]==target){
				this.floors.splice(ii,1)
				break
			}
		}
		if(this.floors.length==0){
			this.dad.removeBuilding(this)
		}
		WORLD.update()
		this.update()
	}
	this.removeRoom = function(target){
		for(var ii=0;ii<this.rooms.length;ii++){
			if(this.rooms[ii]==target){
				this.rooms.splice(ii,1)
				break
			}
		}
		WORLD.update()
	}
	this.move = function(vector){
		for(var ii=1;ii<this.floors.length;ii++){
			this.floors[ii].move(vector)
		}
		for(var ii=0;ii<this.rooms.length;ii++){
			this.rooms[ii].move(vector)
		}
		for(var ii=0;ii<this.portals.length;ii++){
			this.portals[ii].move(vector)
		}
	}
	this.snap = function(){
		for(var ii=1;ii<this.floors.length;ii++){
			this.floors[ii].snap()
		}
		for(var ii=0;ii<this.rooms.length;ii++){
			this.rooms[ii].snap()
		}
		for(var ii=0;ii<this.portals.length;ii++){
			this.portals[ii].snap()
		}
	}
	this.verifyGeometry = function(){
		
	}
	this.calculateSurfaces = function(){
		track = 200
		var surfaces = []
		for(var ii=0;ii<this.portals.length;ii++){
			this.portals[ii].A = 0
			this.portals[ii].B = 0
		}
		for(var ii=0;ii<this.floors.length;ii++){
			surfaces = surfaces.concat(this.floors[ii].calculateSurfaces())
		}
		for(var ii=0;ii<this.rooms.length;ii++){
			surfaces = surfaces.concat(this.rooms[ii].calculateSurfaces())
		}
		for(var ii=0;ii<this.portals.length;ii++){
			surfaces = surfaces.concat(this.portals[ii].calculateSurfaces())
		}
		return surfaces
	}
	this.save = function(){
		var total = ""
		for(var ii=0;ii<this.floors.length;ii++){
			total += "F"+this.floors[ii].save() + BUILDING_DELIM
		}
		for(var ii=0;ii<this.rooms.length;ii++){
			total += "R"+this.rooms[ii].save() + BUILDING_DELIM
		}
		for(var ii=0;ii<this.portals.length;ii++){
			total += "P"+this.portals[ii].save() + BUILDING_DELIM
		}
		return total
	}
	this.load = function(worldText){
		var tuple
		var thought = ""
		var textFocus = 0
		
		this.floors = []
		while(textFocus<worldText.length){
			tuple = gatherThoughts(worldText,textFocus,BUILDING_DELIM)
			thought = tuple[0]
			textFocus = tuple[1]
			if(thought[0]=="F"){
				this.addFloor(thought.slice(1))
			}
			if(thought[0]=="R"){
				this.addRoom(thought.slice(1))
			}
			if(thought[0]=="P"){
				this.addPortal(thought.slice(1))
			}
		}
	}
	this.exportVMF = function(){
		var worldObjects = []
		var entityObjects = []
		/*for(var ii=0;ii<this.portals.length;ii++){
			this.portals[ii].A = 0
			this.portals[ii].B = 0
		}
		for(var ii=0;ii<this.floors.length;ii++){
			var product = this.floors[ii].exportVMF()
			worldObjects = worldObjects.concat(product[0])
			entityObjects = entityObjects.concat(product[1])
		}
		for(var ii=0;ii<this.rooms.length;ii++){
			var product = this.rooms[ii].exportVMF()
			worldObjects = worldObjects.concat(product[0])
			entityObjects = entityObjects.concat(product[1])
		}
		for(var ii=0;ii<this.portals.length;ii++){
			var product = this.portals[ii].exportVMF()
			worldObjects = worldObjects.concat(product[0])
			entityObjects = entityObjects.concat(product[1])
		}*/
		var temp = this.calculateSurfaces()
		for(var ii=0;ii<temp.length;ii++){
			worldObjects = worldObjects.concat(temp[ii].exportVMF())
		}
		return [worldObjects,entityObjects]
	}
}

var World_Prim = function(){
	this.name = "World"
	this.details = ["addBuilding","gridSize"]
	this.border = Square_Border(1024,0,this)
	this.pathElevations = []
	this.gridSize = 128
	this.worldColor = "#ffae23"
	this.buildings = []
	this.catWalks = []
	this.addBuilding = function(worldText){
		this.buildings.push(new Building_Prim(this))
		if(worldText!=undefined){
			this.buildings[this.buildings.length-1].load(worldText)
		}
		this.update()
	}
	this.save = function(){
		var total = this.border.save()+WORLD_DELIM
		for(var ii=0;ii<this.buildings.length;ii++){
			total += "B"+this.buildings[ii].save() + WORLD_DELIM
		}
		makeTextFile(total);
	}
	this.load = function(){
		$('#file_selector').click();
	}
	this.applyText = function(worldText){
		var tuple = gatherThoughts(worldText,0,WORLD_DELIM)
		var thought = tuple[0]
		var textFocus = tuple[1]
		
		this.buildings = []
		this.border.load(thought)
		while(textFocus<worldText.length){
			tuple = gatherThoughts(worldText,textFocus,WORLD_DELIM)
			thought = tuple[0]
			textFocus = tuple[1]
			if(thought[0]=="B"){
				this.addBuilding(thought.slice(1))
			}
		}
		this.update()
	}
	this.remove = function(){}
	this.display = function(){
		
	}
	this.update = function(){
		reality = scene.clone()
		VisibleGridCreator(this.gridSize,12800)
		OBJECTS = [this.border.display()]
		for(var ii=0;ii<this.buildings.length;ii++){
			var stuff = this.buildings[ii].display()
			for(var jj=0;jj<stuff.length;jj++){
				OBJECTS.push(stuff[jj])
			}
		}
	}
	this.edit = function(){
		this.border.edit()
	}
	this.removeBuilding = function(target){
		for(var ii=0;ii<this.buildings.length;ii++){
			if(this.buildings[ii]==target){
				this.buildings.splice(ii,1)
				break
			}
		}
		WORLD.update()
	}
	this.calculateSurfaces = function(){
		track = 0
		var surfaces = []
		for(var ii=0;ii<this.buildings.length;ii++){
			surfaces = surfaces.concat(this.buildings[ii].calculateSurfaces())
		}
		for(var ii=0;ii<surfaces.length;ii++){
			var geos = surfaces[ii].genMesh()
			for(var jj=0;jj<geos.length;jj++){
				geos[jj].computeFaceNormals()
				geos[jj].computeVertexNormals()
				geos[jj].computeMorphNormals()
				reality.add(new THREE.Mesh(geos[jj],surfaces[ii].material))
			}
		}
		
		return surfaces
	}
	this.exportVMF = function(){
		var worldObjects = []
		var entityObjects = []
		for(var ii=0;ii<this.buildings.length;ii++){
			var product = this.buildings[ii].exportVMF()
			worldObjects = worldObjects.concat(product[0])
			entityObjects = entityObjects.concat(product[1])
		}
		//shit
		console.log(worldObjects)
		var id = 2
		var total = 'world\n\
{\n\
	"id" "1"\n'
		for(var ii=0;ii<worldObjects.length;ii++){
			var product = worldObjects[ii].genText(id)
			total+=product[0]
			id = product[1]
		}
		total+='}'
		makeTextFile(total);
	}
}


//The Base floor of a building is widened and formalized into a foundation
//Each floor is then inset by -8 HU
//Rooms can touch floor walls, and other rooms, but may not intersect.
//Rooms are inset by 8 HU